   This file documents the XEmacs editor.

   Copyright (C) 1985, 1986, 1988 Richard M. Stallman.  Copyright (C)
1991, 1992, 1993, 1994 Lucid, Inc.  Copyright (C) 1993, 1994 Sun
Microsystems, Inc.  Copyright (C) 1995 Amdahl Corporation.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided also
that the sections entitled "The GNU Manifesto", "Distribution" and "GNU
General Public License" are included exactly as in the original, and
provided that the entire resulting derived work is distributed under the
terms of a permission notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that the sections entitled "The GNU Manifesto",
"Distribution" and "GNU General Public License" may be included in a
translation approved by the author instead of in the original English.

The Mark and the Region
-----------------------

   The concept of the mark applies to the calendar just as to any other
buffer, but it marks a *date*, not a *position* in the buffer.  The
region consists of the days between the mark and point (including the
starting and stopping dates).

`C-SPC'
     Set the mark to today's date (`calendar-set-mark').

`C-@'
     The same.

`C-x C-x'
     Interchange mark and point (`calendar-exchange-point-and-mark').

`M-='
     Display the number of days in the current region
     (`calendar-count-days-region').

   You set the mark in the calendar, as in any other buffer, by using
`C-@' or `C-SPC' (`calendar-set-mark').  You return to the marked date
with the command `C-x C-x' (`calendar-exchange-point-and-mark') which
puts the mark where point was and point where mark was.  The calendar
is scrolled as necessary, if the marked date was not visible on the
screen.  This does not change the extent of the region.

   To determine the number of days in the region, type `M-='
(`calendar-count-days-region').  The numbers of days printed is
*inclusive*, that is, includes the days specified by mark and point.

   The main use of the mark in the calendar is to remember dates that
you may want to go back to.  To make this feature more useful, the mark
ring (see Mark Ring.) operates exactly as in other buffers:  Emacs
remembers 16 previous locations of the mark.  To return to a marked
date, type `C-u C-SPC' (or `C-u C-@'); this is the command
`calendar-set-mark' given a numeric argument.  It moves point to where
the mark was, restores the mark from the ring of former marks, and
stores the previous point at the end of the mark ring.  So, repeated
use of this command moves point through all the old marks on the ring,
one by one.

Miscellaneous Calendar Commands
-------------------------------

`p d'
     Display day-in-year (`calendar-print-day-of-year').

`?'
     Briefly describe calendar commands (`describe-calendar-mode').

`SPC'
     Scroll the next window (`scroll-other-window').

`C-c C-l'
     Regenerate the calendar window (`redraw-calendar').

`q'
     Exit from calendar (`exit-calendar').

   If you want to know how many days have elapsed since the start of
the year, or the number of days remaining in the year, type the `p d'
command (`calendar-print-day-of-year').  This displays both of those
numbers in the echo area.

   To display a brief description of the calendar commands, type `?'
(`describe-calendar-mode').  For a fuller description, type `C-h m'.

   You can use `SPC' (`scroll-other-window') to scroll the other
window.  This is handy when you display a list of holidays or diary
entries in another window.

   If the calendar window gets corrupted, type `C-c C-l'
(`redraw-calendar') to redraw it.

   To exit from the calendar, type `q' (`exit-calendar').  This buries
all buffers related to the calendar and returns the window display to
what it was when you entered the calendar.

Holidays
--------

   The Emacs calendar knows about all major and many minor holidays.

`h'
     Display holidays for the date indicated by point
     (`calendar-cursor-holidays').

`x'
     Mark holidays in the calendar window (`mark-calendar-holidays').

`u'
     Unmark calendar window (`calendar-unmark').

`a'
     List all holidays for the displayed three months in another window
     (`list-calendar-holidays').

`M-x holidays'
     List all holidays for three months around today's date in another
     window.

   To see if any holidays fall on a given date, position point on that
date in the calendar window and use the `h' command.  The holidays are
usually listed in the echo area, but if there are too many to fit in
one line, then they are displayed in a separate window.

   To find the distribution of holidays for a wider period, you can use
the `x' command.  This places a `*' next to every date on which a
holiday falls.  The command applies both to the currently visible dates
and to new dates that become visible by scrolling.  To turn marking off
and erase the current marks, type `u', which also erases any diary
marks (see Diary.).

   To get even more detailed information, use the `a' command, which
displays a separate buffer containing a list of all holidays in the
current three-month range.

   You can display the list of holidays for the current month and the
preceding and succeeding months even if you don't have a calendar
window.  Use the command `M-x holidays'.  If you want the list of
holidays centered around a different month, use `C-u M-x holidays' and
type the month and year.

   The holidays known to Emacs include American holidays and the major
Christian, Jewish, and Islamic holidays; when floating point is
available, Emacs also knows about solstices and equinoxes.  The dates
used by Emacs for holidays are based on *current practice*, not
historical fact.  Historically, for instance, the start of daylight
savings time and even its existence have varied from year to year.
However present American law mandates that daylight savings time begins
on the first Sunday in April; this is the definition that Emacs uses,
even though it is wrong for some prior years.

Times of Sunrise and Sunset
---------------------------

   Emacs can tell you, to within a minute or two, the times of sunrise
and sunset for any date, if floating point is available.

`S'
     Display times of sunrise and sunset for the date indicated by point
     (`calendar-sunrise-sunset').

`M-x sunrise-sunset'
     Display times of sunrise and sunset for today's date.

   Move point to the date you want, and type `S', to display the *local
times* of sunrise and sunset in the echo area.

   You can display the times of sunrise and sunset for the current date
even if you don't have a calendar window.  Use the command `M-x
sunrise-sunset'.  If you want the times of sunrise and sunset for a
different date, use `C-u M-x sunrise-sunset' and type the year, month,
and day.

   Because the times of sunrise and sunset depend on the location on
earth, you need to tell Emacs your latitude, longitude, and location
name.  Here is an example of what to set:

     (setq calendar-latitude 40.1)
     (setq calendar-longitude -88.2)
     (setq calendar-location-name "Urbana, IL")

Use one decimal place in the values of `calendar-latitude' and
`calendar-longitude'.

   Your time zone also affects the local time of sunrise and sunset.
Emacs usually gets this information from the operating system, but if
these values are not what you want (or if the operating system does not
supply them), you'll need to set them yourself, like this:

     (setq calendar-time-zone -360)
     (setq calendar-standard-time-zone-name "CST")
     (setq calendar-daylight-time-zone-name "CDT")

The value of `calendar-time-zone' is the number of minutes difference
between your local standard time and Universal Time (Greenwich time).
The values of `calendar-standard-time-zone-name' and
`calendar-daylight-time-zone-name' are the abbreviations used in your
time zone.

   Emacs displays the times of sunrise and sunset *corrected for
daylight savings time* (this convenience is unusual; most tables of
sunrise and sunset use standard time).  The default rule for the
starting and stopping dates of daylight savings time is the American
rule.  See Daylight Savings

   You can display the times of sunrise and sunset for any location and
any date with `C-u C-u M-x sunrise-sunset'.  Emacs asks you for a
longitude, latitude, number of minutes difference from Universal time,
and date, and then tells you the times of sunrise and sunset for that
location on that date.  The times are usually given in the echo area,
but if the message is too long fit in one line, they are displayed in a
separate window.

Phases of the Moon
------------------

   Emacs can tell you the dates and times of the phases of the moon (new
moon, first quarter, full moon, last quarter), if floating point is
available.

`M'
     List, in another window, the dates and times for all the quarters
     of the moon for the three-month period shown in the calendar window
     (`calendar-phases-of-moon').

`M-x phases-of-moon'
     List dates and times of the quarters of the moon for three months
     around today's date in another window.

   Use the `M' command to display a separate buffer of the phases of
the moon for the current three-month range.  The dates and times listed
are accurate to within a few minutes.

   You can display the list of the phases of the moon for the current
month and the preceding and succeeding months even if you don't have a
calendar window.  Use the command `M-x phases-of-moon'.  If you want
the phases of the moon centered around a different month, use `C-u M-x
phases-of-moon' and type the month and year.

   The dates and times given for the phases of the moon are given in
local time (corrected for daylight savings, when appropriate); but if
the variable `calendar-time-zone' is void, Universal Time (the
Greenwich time zone) is used.  See Daylight Savings

Our Calendar and Other Calendars
--------------------------------

   The Emacs calendar displayed is *always* the Gregorian calendar,
sometimes called the "new style" calendar, which is used in most of the
world today.  However, this calendar did not exist before the sixteenth
century and was not widely used before the eighteenth century; it did
not fully displace the Julian calendar and gain universal acceptance
until the early twentieth century.  This poses a problem for the Emacs
calendar: you can ask for the calendar of any month starting with
January, year 1 of the current era, but the calendar displayed is the
Gregorian, even for a date at which the Gregorian calendar did not
exist!

   Emacs knows about several different calendars, though, not just the
Gregorian calendar.  The following commands describe the date indicated
by point in various calendar notations:

`p c'
     Display ISO commercial calendar equivalent for selected day
     (`calendar-print-iso-date').

`p j'
     Display Julian date for selected day
     (`calendar-print-julian-date').

`p a'
     Display astronomical (Julian) day number for selected day
     (`calendar-print-astro-day-number').

`p h'
     Display Hebrew date for selected day
     (`calendar-print-hebrew-date').

`p i'
     Display Islamic date for selected day
     (`calendar-print-islamic-date').

`p f'
     Display French Revolutionary date for selected day
     (`calendar-print-french-date').

`p m'
     Display Mayan date for selected day (`calendar-print-mayan-date').

   If you are interested in these calendars, you can convert dates one
at a time.  Put point on the desired date of the Gregorian calendar and
press the appropriate keys.  The `p' is a mnemonic for "print" since
Emacs "prints' the equivalent date in the echo area.

   The ISO commercial calendar is used largely in Europe.

   The Julian calendar, named after Julius Caesar, was the one used in
Europe throughout medieval times, and in many countries up until the
nineteenth century.

   Astronomers use a simple counting of days elapsed since noon, Monday,
January 1, 4713 B.C. on the Julian calendar.  The number of days elapsed
is called the *Julian day number* or the *Astronomical day number*.

   The Hebrew calendar is the one used to determine the dates of Jewish
holidays.  Hebrew calendar dates begin and end at sunset.

   The Islamic (Moslem) calendar is the one used to determine the dates
of Moslem holidays.  There is no universal agreement in the Islamic
world about the calendar; Emacs uses a widely accepted version, but the
precise dates of Islamic holidays often depend on proclamation by
religious authorities, not on calculations.  As a consequence, the
actual dates of occurrence can vary slightly from the dates computed by
Emacs.  Islamic calendar dates begin and end at sunset.

   The French Revolutionary calendar was created by the Jacobins after
the 1789 revolution, to represent a more secular and nature-based view
of the annual cycle, and to install a 10-day week in a rationalization
measure similar to the metric system.  The French government officially
abandoned this calendar at the end of 1805.

   The Maya of Central America used three separate, overlapping calendar
systems, the *long count*, the *tzolkin*, and the *haab*.  Emacs knows
about all three of these calendars.  Experts dispute the exact
correlation between the Mayan calendar and our calendar; Emacs uses the
Goodman-Martinez-Thompson correlation in its calculations.

   You can move to dates that you specify on the Commercial, Julian,
astronomical, Hebrew, Islamic, or French calendars:

`g c'
     Move point to a date specified by the ISO commercial calendar
     (`calendar-goto-iso-date').

`g j'
     Move point to a date specified by the Julian calendar
     (`calendar-goto-julian-date').

`g a'
     Move point to a date specified by astronomical (Julian) day number
     (`calendar-goto-astro-day-number').

`g h'
     Move point to a date specified by the Hebrew calendar
     (`calendar-goto-hebrew-date').

`g i'
     Move point to a date specified by the Islamic calendar
     (`calendar-goto-islamic-date').

`g f'
     Move point to a date specified by the French Revolutionary calendar
     (`calendar-goto-french-date').

   These commands ask you for a date on the other calendar, move point
to the Gregorian calendar date equivalent to that date, and display the
other calendar's date in the echo area.  Emacs uses strict completion
(see Completion.) whenever it asks you to type a month name, so you
don't have to worry about the spelling of Hebrew, Islamic, or French
names.

   One common question concerning the Hebrew calendar is the computation
of the anniversary of a date of death, called a "yahrzeit."  The Emacs
calendar includes a facility for such calculations.  If you are in the
calendar, the command `M-x list-yahrzeit-dates' asks you for a range of
years and then displays a list of the yahrzeit dates for those years
for the date given by point.  If you are not in the calendar, this
command first asks you for the date of death and the range of years,
and then displays the list of yahrzeit dates.

   Emacs also has many commands for movement on the Mayan calendars.

`g m l'
     Move point to a date specified by the Mayan long count calendar
     (`calendar-goto-mayan-long-count-date').

`g m p t'
     Move point to the previous occurrence of a date specified by the
     Mayan tzolkin calendar (`calendar-previous-tzolkin-date').

`g m n t'
     Move point to the next occurrence of a date specified by the Mayan
     tzolkin calendar (`calendar-next-tzolkin-date').

`g m p h'
     Move point to the previous occurrence of a date specified by the
     Mayan haab calendar (`calendar-previous-haab-date').

`g m n h'
     Move point to the next occurrence of a date specified by the Mayan
     haab calendar (`calendar-next-haab-date').

`g m p c'
     Move point to the previous occurrence of a date specified by the
     Mayan calendar round (`calendar-previous-calendar-round-date').

`g m n c'
     Move point to the next occurrence of a date specified by the Mayan
     calendar round (`calendar-next-calendar-round-date').

   To understand these commands, you need to understand the Mayan
calendars.  The long count is a counting of days with units

1 kin
     = 1  day

1 uinal
     = 20 kin

1 tun
     = 18 uinal

1 katun
     = 20 tun

1 baktun
     = 20 katun

Thus, the long count date 12.16.11.16.6 means 12 baktun, 16 katun, 11
tun, 16 uinal, and 6 kin.  The Emacs calendar can handle Mayan long
count dates as early as 7.17.18.13.1, but no earlier.  When you use the
`g m l' command, type the Mayan long count date with the baktun, katun,
tun, uinal, and kin separated by periods.

   The Mayan tzolkin calendar is a cycle of 260 days formed by a pair of
independent cycles of 13 and 20 days.  Like the haab cycle, this cycle
repeats endlessly, and you can go backward and forward to the previous
or next (respectively) point in the cycle.  When you type `g m p t',
Emacs asks you for a tzolkin date and moves point to the previous
occurrence of that date; type `g m n t' to go to the next occurrence.

   The Mayan haab calendar is a cycle of 365 days arranged as 18 months
of 20 days each, followed a 5-day monthless period.  Since this cycle
repeats endlessly, Emacs lets you go backward and forward to the
previous or next (respectively) point in the cycle.  Type `g m p h' to
go to the previous haab date; Emacs asks you for a haab date and moves
point to the previous occurrence of that date.  Similarly, type `g m n
h' to go to the next haab date.

   The Maya also used the combination of the tzolkin date and the haab
date.  This combination is a cycle of about 52 years called a *calendar
round*.  If you type `g m p c', Emacs asks you for both a haab and a
tzolkin date and then moves point to the previous occurrence of that
combination.  Use `g m p c' to move point to the next occurrence.
Emacs signals an error if the haab/tzolkin date you have typed cannot
occur.

   Emacs uses strict completion (see Completion.) whenever it asks
you to type a Mayan name, so you don't have to worry about spelling.

The Diary
---------

   Associated with the Emacs calendar is a diary that keeps track of
appointments or other events on a daily basis.  To use the diary
feature, you must first create a "diary file" containing a list of
events and their dates.  Then Emacs can automatically pick out and
display the events for today, for the immediate future, or for any
specified date.

   By default, Emacs expects your diary file to be named `~/diary'.  It
uses the same format as the `calendar' utility.  A sample `~/diary'
file is:

     12/22/1988 Twentieth wedding anniversary!!
     &1/1. Happy New Year!
     10/22 Ruth's birthday.
     * 21, *: Payday
     Tuesday--weekly meeting with grad students at 10am
              Supowit, Shen, Bitner, and Kapoor to attend.
     1/13/89 Friday the thirteenth!!
     &thu 4pm squash game with Lloyd.
     mar 16 Dad's birthday
     April 15, 1989 Income tax due.
     &* 15 time cards due.

   Although you probably will start by creating a diary manually, Emacs
provides a number of commands to let you view, add, and change diary
entries.  You can also share diary entries with other users (see
Included Diary Files.).

Commands Displaying Diary Entries
---------------------------------

   Once you have created a `~/diary' file, you can view it within
Calendar mode.  You can also view today's events independently of
Calendar mode.

`d'
     Display any diary entries for the selected date
     (`view-diary-entries').

`s'
     Display entire diary file (`show-all-diary-entries').

`m'
     Mark all visible dates that have diary entries
     (`mark-diary-entries').

`u'
     Unmark calendar window (`calendar-unmark').

`M-x print-diary-entries'
     Print a hard copy of the diary display as it appears.

`M-x diary'
     Display any diary entries for today's date.

   Displaying the diary entries with `d' shows in a separate window the
diary entries for the date indicated by point in the calendar window.
The mode line of the new window shows the date of the diary entries and
any holidays that fall on that date.

   If you specify a numeric argument with `d', then all the diary
entries for that many successive days are shown.  Thus, `2 d' displays
all the entries for the selected date and for the following day.

   To get a broader overview of which days are mentioned in the diary,
use the `m' command to mark those days in the calendar window.  The
marks appear next to the dates to which they apply.  The `m' command
affects the dates currently visible and, if you scroll the calendar,
newly visible dates as well.  The `u' command deletes all diary marks
(and all holiday marks too; see Holidays.), not only in the dates
currently visible, but dates that become visible when you scroll the
calendar.

   For more detailed information, use the `s' command, which displays
the entire diary file.

   Display of selected diary entries uses the selective display feature,
the same feature that Outline mode uses to show part of an outline
(see Outline Mode.).  This involves hiding the diary entries that
are not relevant, by changing the preceding newline into an ASCII
control-m (code 015).  The hidden lines are part of the buffer's text,
but they are invisible; they don't appear on the screen.  When you save
the diary file, the control-m characters are saved as newlines; thus,
the invisible lines become ordinary lines in the file.

   Because the diary buffer as you see it is an illusion, simply
printing the contents does not print what you see on your screen.  So
there is a special command to print a hard copy of the buffer *as it
appears*; this command is `M-x print-diary-entries'.  It sends the data
directly to the printer.  You can customize it like `lpr-region' (see
Hardcopy.).

   The command `M-x diary' displays the diary entries for the current
date, independently of the calendar display, and optionally for the next
few days as well; the variable `number-of-diary-entries' specifies how
many days to include (see Customization.).

   If you put in your `.emacs' file:

     (diary)

it automatically displays a window with the day's diary entries, when
you enter Emacs.  The mode line of the displayed window shows the date
and any holidays that fall on that date.

The Diary File
--------------

   Your "diary file" is a file that records events associated with
particular dates.  The name of the diary file is specified by the
variable `diary-file'; `~/diary' is the default.  You can use the same
file for the `calendar' utility program, since its formats are a subset
of the ones allowed by the Emacs Calendar.

   Each entry in the file describes one event and consists of one or
more lines.  It always begins with a date specification at the left
margin.  The rest of the entry is simply text to describe the event.
If the entry has more than one line, then the lines after the first
must begin with whitespace to indicate they continue a previous entry.

   Here are some sample diary entries, illustrating different ways of
formatting a date.  The examples all show dates in American order
(month, day, year), but Calendar mode offers (day, month, year)
ordering too.

     4/20/93  Switch-over to new tabulation system
     apr. 25  Start tabulating annual results
     4/30  Results for April are due
     */25  Monthly cycle finishes
     Friday  Don't leave without backing up files

   The first entry appears only once, on April 20, 1993.  The second and
third appear every year on the specified dates, and the fourth uses a
wildcard (asterisk) for the month, so it appears on the 25th of every
month.  The final entry appears every week on Friday.

   You can also use just numbers to express a date, as in `MONTH/DAY' or
`MONTH/DAY/YEAR'.  This must be followed by a nondigit.  In the date
itself, MONTH and DAY are numbers of one or two digits.  YEAR is a
number and may be abbreviated to the last two digits; that is, you can
use `11/12/1989' or `11/12/89'.

   A date may be "generic", or partially unspecified.  Then the entry
applies to all dates that match the specification.  If the date does
not contain a year, it is generic and applies to any year.
Alternatively, MONTH, DAY, or YEAR can be a `*'; this matches any
month, day, or year, respectively.  Thus, a diary entry `3/*/*' matches
any day in March of any year.

   Dates can also have the form `MONTHNAME DAY' or `MONTHNAME DAY,
YEAR', where the month's name can be spelled in full or abbreviated to
three characters (with or without a period).  Case is not significant.
If the date does not contain a year, it is generic and applies to any
year.  Also, MONTHNAME, DAY, or YEAR can be a `*' which matches any
month, day, or year, respectively.

   If you prefer the European style of writing dates--in which the day
comes before the month--type `M-x european-calendar' while in the
calendar, or set the variable `european-calendar-style' to `t' in your
`.emacs' file *before* the calendar or diary command.  This mode
interprets all dates in the diary in the European manner, and also uses
European style for displaying diary dates.  (Note that there is no
comma after the MONTHNAME in the European style.)

   To revert to the (default) American style of writing dates, type `M-x
american-calendar'.

   You can use the name of a day of the week as a generic date which
applies to any date falling on that day of the week.  You can abbreviate
the day of the week to three letters (with or without a period) or spell
it in full; it need not be capitalized.

   You can inhibit the marking of certain diary entries in the calendar
window; to do this, insert an ampersand (`&') at the beginning of the
entry, before the date.  This has no effect on display of the entry in
the diary window; it affects only marks on dates in the calendar
window.  Nonmarking entries are especially useful for generic entries
that would otherwise mark many different dates.

   Lines that do not begin with valid dates and do not continue a
preceding entry are ignored.

   If the first line of a diary entry consists only of the date or day
name with no following blanks or punctuation, then the diary window
display doesn't include that line; only the continuation lines appear.
For example:

     02/11/1989
           Bill B. visits Princeton today
           2pm Cognitive Studies Committee meeting
           2:30-5:30 Liz at Lawrenceville
           4:00pm Dentist appt
           7:30pm Dinner at George's
           8:00-10:00pm concert

appears in the diary window without the date line at the beginning.
This style of entry looks neater when you display just a single day's
entries, but can cause confusion if you ask for more than one day's
entries.

   You can edit the diary entries as they appear in the window, but it
is important to remember that the buffer displayed contains the *entire*
diary file, with portions of it concealed from view.  This means, for
instance, that the `C-f' (`forward-char') command can put point at what
appears to be the end of the line, but what is in reality the middle of
some concealed line.  *Be careful when editing the diary entries!*
Inserting additional lines or adding/deleting characters in the middle
of a visible line cannot cause problems.  Watch out for `C-e'
(`end-of-line'), however; it may put you at the end of a concealed line
far from where point appears to be!  Before editing the diary, it is
best to display the entire file with `s' (`show-all-diary-entries').

   While in the calendar, there are several commands to help you in
making entries to your diary.

`i d'
     Add a diary entry for the selected date (`insert-diary-entry').

`i w'
     Add a diary entry for the selected day of the week
     (`insert-weekly-diary-entry').

`i m'
     Add a diary entry for the selected day of the month
     (`insert-monthly-diary-entry').

`i y'
     Add a diary entry for the selected day of the year
     (`insert-yearly-diary-entry').

   You can make a diary entry for a specific date by moving point to
that date in the calendar window and using the `i d' command.  This
command displays the end of your diary file in another window and
inserts the date; you can then type the rest of the diary entry.

   If you want to make a diary entry that applies to a specific day of
the week, move point to that day of the week (any occurrence will do)
and use the `i w' command.  This displays the end of your diary file in
another window and inserts the day-of-week as a generic date; you can
then type the rest of the diary entry.

   You make a monthly diary entry in the same fashion.  Move point to
the day of the month, use the `i m' command, and type the diary entry.
Similarly, you make a yearly diary entry with the `i y' command.

   All of the above commands make marking diary entries.  If you want
the diary entry to be nonmarking, give a prefix argument to the
command.  For example, `C-u i w' makes a nonmarking, weekly diary entry.

   If you modify the diary, be sure to write the file before exiting
from the calendar.

Special Diary Entries
---------------------

   In addition to entries based on calendar dates, your diary file can
contain entries for regularly occurring events such as anniversaries.
These entries are based on expressions (sexps) that Emacs evaluates as
it scans the diary file.  Such an entry is indicated by `%%' at the
beginning (preceded by `&' for a nonmarking entry), followed by a sexp
in parentheses.  Calendar mode offers commands to make it easier to put
some of these special entries in your diary.

`i a'
     Add an anniversary diary entry for the selected date
     (`insert-anniversary-diary-entry').

`i b'
     Add a block diary entry for the current region
     (`insert-block-diary-entry').

`i c'
     Add a cyclic diary entry starting at the date
     (`insert-cyclic-diary-entry').

   If you want to make a diary entry that applies to the anniversary of
a specific date, move point to that date and use the `i a' command.
This displays the end of your diary file in another window and inserts
the anniversary description; you can then type the rest of the diary
entry.

   The effect of `i a' is to add a `diary-anniversary' sexp to your
diary file.  You can also add one manually, for instance:

     %%(diary-anniversary 10 31 1948) Arthur's birthday

This entry applies to October 31 in any year after 1948; `10 31 1948'
specifies the date.  (If you are using the European calendar style, the
month and day are interchanged.)  The reason this sexp requires a
beginning year is that advanced diary functions can use it to calculate
the number of elapsed years (see Sexp Diary Entries.).

   You can make a diary entry for a block of dates by setting the mark
at the date at one end of the block, moving point to the date at the
other end of the block, and using the `i b' command.  This command
causes the end of your diary file to be displayed in another window and
the block description to be inserted; you can then type the diary entry.

   Here is such a diary entry that applies to all dates from June 24,
1990 through July 10, 1990:

     %%(diary-block 6 24 1990 7 10 1990) Vacation

The `6 24 1990' indicates the starting date and the `7 10 1990'
indicates the stopping date.  (Again, if you are using the European
calendar style, the month and day are interchanged.)

   You can specify cyclic diary entries that repeat after a fixed
interval of days.  Move point to the starting date and use the `i c'
command.  After you specify the length of interval, this command
displays the end of your diary file in another window and inserts the
cyclic event description; you can then type the rest of the diary entry.

   The sexp corresponding to the `i c' command looks like:

     %%(diary-cyclic 50 3 1 1990) Renew medication

which applies to March 1, 1990 and every 50th day following; `3 1 1990'
specifies the starting date.  (If you are using the European calendar
style, the month and day are interchanged.)

   All three of the these commands make marking diary entries.  If you
want the diary entry to be nonmarking, give a numeric argument to the
command.  For example, `C-u i a' makes a nonmarking anniversary diary
entry.

   Marking sexp diary entries in the calendar is *extremely*
time-consuming, since every date visible in the calendar window must be
individually checked.  So it's a good idea to make sexp diary entries
nonmarking with `&'.

   One sophisticated kind of sexp, a floating diary entry, has no
corresponding command.  The floating diary entry specifies a
regularly-occurring event by offsets specified in days, weeks, and
months.  It is comparable to a crontab entry interpreted by the `cron'
utility on Unix systems.

   Here is a nonmarking, floating diary entry that applies to the last
Thursday in November:

     &%%(diary-float 11 4 -1) American Thanksgiving

The 11 specifies November (the eleventh month), the 4 specifies Thursday
(the fourth day of the week, where Sunday is numbered zero), and the -1
specifies "last" (1 would mean "first", 2 would mean "second", -2 would
mean "second-to-last", and so on).  The month can be a single month or
a list of months.  Thus you could change the 11 above to `'(1 2 3)' and
have the entry apply to the last Thursday of January, February, and
March.  If the month is `t', the entry applies to all months of the
year.

   The sexp feature of the diary allows you to specify diary entries
based on any Emacs Lisp expression.  You can use the library of built-in
functions or you can write your own functions.  The built-in functions
include the ones shown in this section, plus a few others (see Sexp Diary Entries.).

   The generality of sexps lets you specify any diary entry that you can
describe algorithmically.  Suppose you get paid on the 21st of the month
if it is a weekday, and to the Friday before if the 21st is on a
weekend.  The diary entry

     &%%(let ((dayname (calendar-day-of-week date))
              (day (car (cdr date))))
           (or (and (= day 21) (memq dayname '(1 2 3 4 5)))
               (and (memq day '(19 20)) (= dayname 5)))
              ) Pay check deposited

to just those dates.  This example illustrates how the sexp can depend
on the variable `date'; this variable is a list (MONTH DAY YEAR) that
gives the Gregorian date for which the diary entries are being found.
If the value of the sexp is `t', the entry applies to that date.  If
the sexp evaluates to `nil', the entry does *not* apply to that date.

Customizing the Calendar and Diary
----------------------------------

   There are many customizations that you can use to make the calendar
and diary suit your personal tastes.

Customizing the Calendar
........................

   If you set the variable `view-diary-entries-initially' to `t',
calling up the calendar automatically displays the diary entries for
the current date as well.  The diary dates appear only if the current
date is visible.  If you add both of the following lines to your
`.emacs' file:

     (setq view-diary-entries-initially t)
     (calendar)

they display both the calendar and diary windows whenever you start
Emacs.

   Similarly, if you set the variable
`view-calendar-holidays-initially' to `t', entering the calendar
automatically displays a list of holidays for the current three month
period.  The holiday list appears in a separate window.

   You can set the variable `mark-diary-entries-in-calendar' to `t' in
order to place a plus sign (`+') beside any dates with diary entries.
Whenever the calendar window is displayed or redisplayed, the diary
entries are automatically marked for holidays.

   Similarly, setting the variable `mark-holidays-in-calendar' to `t'
places an asterisk (`*') after all holiday dates visible in the
calendar window.

   There are many customizations that you can make with the hooks
provided.  For example, the variable `calendar-load-hook', whose
default value is `nil', is a normal hook run when the calendar package
is first loaded (before actually starting to display the calendar).

   The variable `initial-calendar-window-hook', whose default value is
`nil', is a normal hook run the first time the calendar window is
displayed.  The function is invoked only when you first enter Calendar
mode, not when you redisplay an existing Calendar window.  But if you
leave the calendar with the `q' command and reenter it, the hook runs
again.

   The variable `today-visible-calendar-hook', whose default value is
`nil', is a normal hook run after the calendar buffer has been prepared
with the calendar when the current date is visible in the window.  One
use of this hook is to replace today's date with asterisks; a function
`calendar-star-date' is included for this purpose.  In your `.emacs'
file, put:

     (setq today-visible-calendar-hook 'calendar-star-date)

Another standard hook function adds asterisks around the current date.
Here's how to use it:

     (setq today-visible-calendar-hook 'calendar-mark-today)

A corresponding variable, `today-invisible-calendar-hook', whose
default value is `nil', is a normal hook run after the calendar buffer
text has been prepared, if the current date is *not* visible in the
window.

Customizing the Holidays
........................

   Emacs knows about holidays defined by entries on one of several
lists.  You can customize theses lists of holidays to your own needs,
adding holidays or deleting lists of holidays.  The lists of holidays
that Emacs uses are for general holidays (`general-holidays'), local
holidays (`local-holidays'), Christian holidays (`christian-holidays'),
Hebrew (Jewish) holidays (`hebrew-holidays'), Islamic (Moslem) holidays
(`islamic-holidays'), and other holidays (`other-holidays').

   The general holidays are, by default, holidays common throughout the
United States.  To eliminate these holidays, set `general-holidays' to
`nil'.

   There are no default local holidays (but sites may supply some).  You
can set the variable `local-holidays' to any list of holidays, as
described below.

   By default, Emacs does not consider all the holidays of these
religions, only those commonly found in secular calendars.  For a more
extensive collection of religious holidays, you can set any (or all) of
the variables `all-christian-calendar-holidays',
`all-hebrew-calendar-holidays', or `all-islamic-calendar-holidays' to
`t'.  If you want to eliminate the religious holidays, set any or all
of the corresponding variables `christian-holidays', `hebrew-holidays',
and `islamic-holidays' to `nil'.

   You can set the variable `other-holidays' to any list of holidays.
This list, normally empty, is intended for your use.

   Each of the lists (`general-holidays', `local-holidays',
`christian-holidays', `hebrew-holidays', `islamic-holidays', and
`other-holidays') is a list of "holiday forms", each holiday form
describing a holiday (or sometimes a list of holidays).  Holiday forms
may have the following formats:

`(holiday-fixed MONTH DAY STRING)'
     A fixed date on the Gregorian calendar.  MONTH and DAY are
     numbers, STRING is the name of the holiday.

`(holiday-float MONTH DAYNAME K STRING)'
     The Kth DAYNAME in MONTH on the Gregorian calendar (DAYNAME=0 for
     Sunday, and so on); negative K means count back from the end of
     the month.  STRING is the name of the holiday.

`(holiday-hebrew MONTH DAY STRING)'
     A fixed date on the Hebrew calendar.  MONTH and DAY are numbers,
     STRING is the name of the holiday.

`(holiday-islamic MONTH DAY STRING)'
     A fixed date on the Islamic calendar.  MONTH and DAY are numbers,
     STRING is the name of the holiday.

`(holiday-julian MONTH DAY STRING)'
     A fixed date on the Julian calendar.  MONTH and DAY are numbers,
     STRING is the name of the holiday.

`(holiday-sexp SEXP STRING)'
     SEXP is a Lisp expression that should use the variable `year' to
     compute the date of a holiday, or `nil' if the holiday doesn't
     happen this year.  The value represents the date as a list of the
     form `(MONTH DAY YEAR)'.  STRING is the name of the holiday.

`(if BOOLEAN HOLIDAY-FORM &optional HOLIDAY-FORM)'
     A choice between two holidays based on the value of BOOLEAN.

`(FUNCTION &optional ARGS)'
     Dates requiring special computation; ARGS, if any, are passed in a
     list to the function `calendar-holiday-function-FUNCTION'.

   For example, suppose you want to add Bastille Day, celebrated in
France on July 14.  You can do this by adding the following line to
your `.emacs' file:

     (setq other-holidays '((holiday-fixed 7 14 "Bastille Day")))

The holiday form `(holiday-fixed 7 14 "Bastille Day")' specifies the
fourteenth day of the seventh month (July).

   Many holidays occur on a specific day of the week, at a specific time
of month.  Here is a holiday form describing Hurricane Supplication Day,
celebrated in the Virgin Islands on the fourth Monday in August:

     (holiday-float 8 1 4 "Hurricane Supplication Day")

Here the 8 specifies August, the 1 specifies Monday (Sunday is 0,
Tuesday is 2, and so on), and the 4 specifies the fourth occurrence in
the month (1 specifies the first occurrence, 2 the second occurrence,
-1 the last occurrence, -2 the second-to-last occurrence, and so on).

   You can specify holidays that occur on fixed days of the Hebrew,
Islamic, and Julian calendars too.  For example,

     (setq other-holidays
           '((holiday-hebrew 10 2 "Last day of Hanukkah")
             (holiday-islamic 3 12 "Mohammed's Birthday")
             (holiday-julian 4 2 "Jefferson's Birthday")))

adds the last day of Hanukkah (since the Hebrew months are numbered with
1 starting from Nisan), the Islamic feast celebrating Mohammed's
birthday (since the Islamic months are numbered from 1 starting with
Muharram), and Thomas Jefferson's birthday, which is 2 April 1743 on the
Julian calendar.

   To include a holiday conditionally, use either the `if' or the
`sexp' form.  For example, American presidential elections occur on the
first Tuesday after the first Monday in November of years divisible by
4:

     (holiday-sexp (if (= 0 (% year 4))
                        (calendar-gregorian-from-absolute
                      (1+ (calendar-dayname-on-or-before
                            1 (+ 6 (calendar-absolute-from-gregorian
                                     (list 11 1 year))))))
                   "US Presidential Election"))

or

     (if (= 0 (% displayed-year 4))
         (fixed 11
                (extract-calendar-day
                  (calendar-gregorian-from-absolute
                    (1+ (calendar-dayname-on-or-before
                          1 (+ 6 (calendar-absolute-from-gregorian
                                   (list 11 1 displayed-year)))))))
                "US Presidential Election"))

   Some holidays just don't fit into any of these forms because special
calculations are involved in their determination.  In such cases you
must write a Lisp function to do the calculation.  To include eclipses
of the sun, for example, add `(eclipses)' to `other-holidays' and write
an Emacs Lisp function `eclipses' that returns a (possibly empty) list
of the relevant Gregorian dates among the range visible in the calendar
window, with descriptive strings, like this:

     (((6 27 1991) "Lunar Eclipse") ((7 11 1991) "Solar Eclipse") ... )

Date Display Format
...................

   You can customize the manner of displaying dates in the diary, in
mode lines, and in messages by setting `calendar-date-display-form'.
This variable is a list of expressions that can involve the variables
`month', `day', and `year', all numbers in string form, and `monthname'
and `dayname', both alphabetic strings.  In the American style, the
default value of this list is as follows:

     ((if dayname (concat dayname ", ")) monthname " " day ", " year)

while in the European style this value is the default:

     ((if dayname (concat dayname ", ")) day " " monthname " " year)

   The ISO standard date representation is this:

     (year "-" month "-" day)

This specifies a typical American format:

     (month "/" day "/" (substring year -2))

Time Display Format
...................

   In the calendar, diary, and related buffers, Emacs displays times of
day in the conventional American style with the hours from 1 through 12,
minutes, and either `am' or `pm'.  If you prefer the "military"
(European) style of writing times--in which the hours go from 00 to
23--you can alter the variable `calendar-time-display-form'.  This
variable is a list of expressions that can involve the variables
`12-hours', `24-hours', and `minutes', all numbers in string form, and
`am-pm' and `time-zone', both alphabetic strings.  The default
definition of `calendar-time-display-form' is as follows:

     (12-hours ":" minutes am-pm
               (if time-zone " (") time-zone (if time-zone ")"))

   Setting `calendar-time-display-form' to

     (24-hours ":" minutes
               (if time-zone " (") time-zone (if time-zone ")"))

gives military-style times like `21:07 (UT)' if time zone names are
defined, and times like `21:07' if they are not.

Daylight Savings Time
.....................

   Emacs understands the difference between standard time and daylight
savings time--the times given for sunrise, sunset, solstices,
equinoxes, and the phases of the moon take that into account.  The rules
for daylight savings time vary from place to place and have also varied
historically from year to year.  To do the job properly, Emacs needs to
know which rules to use.

   Some operating systems keep track of the rules that apply to the
place where you are; on these systems, Emacs gets the information it
needs from the system automatically.  If some or all of this
information is missing, Emacs fills in the gaps with the rules
currently used in Cambridge, Massachusetts.  If the default choice of
rules is not appropriate for your location, you can tell Emacs the
rules to use by setting certain variables.

   These variables are `calendar-daylight-savings-starts' and
`calendar-daylight-savings-ends'.  Their values should be Lisp
expressions that refer to the variable `year', and evaluate to the
Gregorian date on which daylight savings time starts or (respectively)
ends, in the form of a list `(MONTH DAY YEAR)'.  The values should be
`nil' if your area does not use daylight savings time.

   Emacs uses these expressions to determine the starting date of
daylight savings time for the holiday list and for correcting times of
day in the solar and lunar calculations.

   The values for Cambridge, Massachusetts are as follows:

     (calendar-nth-named-day 1 0 4 year)
     (calendar-nth-named-day -1 0 10 year)

i.e. the first 0th day (Sunday) of the fourth month (April) in the year
specified by `year', and the last Sunday of the tenth month (October)
of that year.  If daylight savings time were changed to start on
October 1, you would set `calendar-daylight-savings-starts' to this:

     (list 10 1 year)

   For a more complex example, suppose daylight savings time begins on
the first of Nisan on the Hebrew calendar.  You would set
`calendar-daylight-savings-starts' as follows:

     (calendar-gregorian-from-absolute
       (calendar-absolute-from-hebrew
         (list 1 1 (+ year 3760))))

because Nisan is the first month in the Hebrew calendar and the Hebrew
year differs from the Gregorian year by 3760 at Nisan.

   If there is no daylight savings time at your location, or if you want
all times in standard time, set `calendar-daylight-savings-starts' and
`calendar-daylight-savings-ends' to `nil'.

   This variable specifies the difference between daylight savings time
and standard time, measured in minutes.  The value for Cambridge is 60.

   These variables specify is the number of minutes after midnight
local time when the transition to and from daylight savings time should
occur.  For Cambridge, both variables' values are 120.